/*This code is created with the Virtual library of Albert van Dalen
Check his Website for more options with this Library
https://avdweb.nl/arduino/timing/virtualdelay

Download the Library from Github
https://github.com/avdwebLibraries/avdweb_VirtualDelay

Implemented as an nonblocking sount player with Piezo Speaker
with Arduino Tone function. by C. van Hal
*/

#include "avdweb_VirtualDelay.h" // Include the VirtualDelay library

#define ButtonPin1 8 // Define the pin for the first button
#define ButtonPin2 7 // Define the pin for the second button
#define PIEZO_PIN 13   // Define the pin for the piezo speaker

// Define VirtualDelay objects for each sound and delay
VirtualDelay VariedTone, delay2, delay3, delay4,
  VariedToneReverse, delay6, delay7, delay8,
  ErrorWarning, delay10, delay11, delay12,
  ClickSound, delay14,
  BeepEnter, delay16, delay17,
  BeepLeave, delay19, delay20;

// Regular setup
void setup() {
  Serial.begin(112500); // Initialize serial communication
  Serial.println("\ntestSequence"); // Print a message to the Serial Monitor
  pinMode(ButtonPin1, INPUT_PULLUP); // Set the first button pin to input with internal pull-up resistor
  pinMode(ButtonPin2, INPUT_PULLUP); // Set the second button pin to input with internal pull-up resistor
  pinMode(PIEZO_PIN, OUTPUT); // Set the piezo pin to output
}

// Main loop
void loop() {
  PlaySound(); // Call the function to play sound
  ButtonPress(); // Call the function to handle button presses
}

// Function to handle button presses
void ButtonPress() {
  if (digitalRead(ButtonPin1) == LOW) { // Check if the first button is pressed
    delay(500); // Add a brief delay
    BeepEnter.start(1); // Start playing a sound using the VirtualDelay object
  }

  if (digitalRead(ButtonPin2) == LOW) { // Check if the second button is pressed
    delay(500); // Add a brief delay
    BeepLeave.start(1); // Start playing a sound using the VirtualDelay object
  }
}

// Function to play sound using non-blocking delays
void PlaySound() {
  // Each section plays a different melody using non-blocking delays
  //============================
  if (VariedTone.elapsed()) {  
    tone(PIEZO_PIN, 1000);     
    delay2.start(100);         
  }
  if (delay2.elapsed()) {  
    tone(PIEZO_PIN, 1200);
    delay3.start(100);
  }
  // ... (additional code for other melodies and delays)
  //============================
}
